#include <iostream>
#include <vector>

typedef unsigned long long int_t;

constexpr int_t M = 1000000007;

int gcd(int x, int y) {
    while (x > 0) {
        y %= x;
        std::swap(x, y);
    }

    return y;
}

std::vector<std::vector<int_t>> make_links(int k) {
    std::vector<std::vector<int_t>> links(k+1);

    for (int x = 1; x < k+1; ++x) {
        for (int y = 1; y < k+1; ++y) {
            if (gcd(x, y) == 1) {
                links[x].push_back(y);
            }
        }
    }

    return links;
}

int main() {
    int_t k, n;
    std::cin >> k >> n;

    auto links = make_links(k);
    std::vector<int_t> values(k+1);
    std::vector<int_t> old(k+1);
    for (int i = 0; i < k; ++i) values[i+1] = 1;

    for (int phase = 0; phase < n-1; ++phase) {
        auto tmp = std::move(old);
        old = std::move(values);
        values = std::move(tmp);
        for (int i = 0; i < k; ++i) values[i+1] = 0;

        for (int i = 1; i < k+1; ++i) {
            for (int poss : links[i]) {
                values[i] = (values[i] + old[poss]) % M;
            }
        }
    }

    int_t result = 0;
    for (int i : values)
        result = (result + i) % M;

    std::cout << result << std::endl;

    return 0;
}
